#!/usr/local/bin/python3

dx = [-2, -2, -1, -1, 1, 1, 2, 2]
dy = [-1, 1, -2, 2, -2, 2, -1, 1]
sz = 8
cnt_step = 2

def get_id(st):
    return ord(st[0]) - ord('A'), int(st[1]) - 1

def get_st(x, y):
    return chr(x + ord('A')) + str(y + 1)

def is_correct(x, y):
    return 0 <= x and x < sz and 0 <= y and y < sz

def get_empty():
    return [[False for j in range(sz)] for i in range(sz)]

x, y = get_id(input())
desk = [get_empty() for k in range(2)]
desk[0][x][y] = True

cur = 0
for step in range(cnt_step):
    for i in range(sz):
        for j in range(sz):
            for k in range(len(dx)):
                if desk[cur][i][j]:
                    nx, ny = i + dx[k], j + dy[k]
                    if is_correct(nx, ny):
                        desk[cur ^ 1][nx][ny] = True

    desk[cur] = get_empty()
    cur ^= 1

for i in range(sz):
    for j in range(sz):
        if desk[cur][j][i]:
            print(get_st(j, i), end=" ")
print()

